#ifndef MAIN_H
#define MAIN_H

#define LED_DDR     DDRB
#define LED_PORT    PORTB
#define LED_PIN     PB5

void lcd_uint16_unit( const uint16_t value, const char unit );
void lastline(void);

uint8_t state_norm_init( void );
uint8_t state_norm_waitkey( void );
uint8_t state_menu_init( uint8_t *mp );
uint8_t state_menu_changed( const uint8_t *mp );
uint8_t state_menu_waitkey( uint8_t *mp );
uint8_t state_val_init( uint8_t *mp);
uint8_t state_val_changed( void );
uint8_t state_val_waitkey(  uint8_t *mp);
// max 65535 == 65.535

// indizes für val_*
#define VAL_AMPS 0
#define VAL_VOLT 1
#define VAL_WATT 2
#define VAL_NONE 255

extern uint16_t val_cur[3];
extern uint16_t val_set[3];

extern const char val_unit[3];

extern const uint16_t powten[5]; 

// extern uint8_t state;
#define STATE_NORM_INIT   0
#define STATE_NORM_WAITKEY    1
#define STATE_MENU_INIT       10
#define STATE_MENU_CHANGED    11
#define STATE_MENU_WAITKEY    12
#define STATE_VAL_INIT        20
#define STATE_VAL_CHANGED     21
#define STATE_VAL_WAITKEY     22

extern uint8_t menuepos;

extern volatile uint8_t cur_mode;
// 0 0 0 0 0 y y x
// x (in)active
// y amp/volt/watt mode
#define CUR_MODE_MASK_ACTIVE    0x01
#define CUR_MODE_IS_ACTIVE      1
#define CUR_MODE_CONST_SHIFT    1
#define CUR_MODE_CONST_MASK     0x06
#define CUR_MODE_CONST_IS_AMPS  ( VAL_AMPS << 1 )
#define CUR_MODE_CONST_IS_VOLT  ( VAL_VOLT << 1 )
#define CUR_MODE_CONST_IS_WATT  ( VAL_WATT << 1 )

#endif // MAIN_H
